indexing

	description: "Describes ?, * or +"

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2001 by Berend de Boer, see forum.txt"
	date:       "$Date: $"
	revision:   "$Revision: $"


class

	CHILD_DEFINITION_OCCURRENCE


inherit

	CHILD_DEFINITION


creation

	make


feature -- creation

	make (a_child: CHILD_DEFINITION; a_min, a_max: INTEGER) is
		require
			valid_child: a_child /= Void
			valid_a_min: a_min >= 0
			valid_a_max: a_max >= 1 and a_max >= a_min
		do
			child := a_child
			min_occurrences := a_min
			max_occurrences := a_max
		end


feature -- state

	min_occurrences: INTEGER

	max_occurrences: INTEGER

	child: CHILD_DEFINITION


feature -- output

	do_generate (xml: EPX_XML_WRITER) is
		do
			xml.set_attribute("type", "occurrence")
			xml.set_attribute("min", min_occurrences.out)
			xml.set_attribute("max", max_occurrences.out)
			child.generate (xml)
		end

end
