indexing

	description: "Describes a single <!ELEMENT children> definition."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2001 by Berend de Boer, see forum.txt"
	date:       "$Date: $"
	revision:   "$Revision: $"


class

	DEFINED_ELEMENT_CHILDREN


inherit

	DEFINED_ELEMENT
		rename
			make as inherited_make
		redefine
			generate_child_definition
		end


creation

	make


feature -- Initialization

	make (a_name: STRING; a_child_definition: CHILD_DEFINITION) is
		require
			name_not_empty: a_name /= Void and then not a_name.is_empty
			child_definition_not_void: a_child_definition /= Void
		do
			inherited_make (a_name)
			child_definition := a_child_definition
		end


feature -- State

	child_definition: CHILD_DEFINITION


feature -- Output

	content_specification: STRING is
		do
			Result := "children"
		end

	generate_child_definition (xml: EPX_XML_WRITER) is
		do
			child_definition.generate (xml)
		end


invariant

	child_definition_not_void: child_definition /= Void

end
