indexing

	description: "DTD contect spec definition."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2001 by Berend de Boer, see forum.txt"
	date:       "$Date: $"
	revision:   "$Revision: $"


deferred class

	CHILD_DEFINITION


feature {DEFINED_ELEMENT, CHILD_DEFINITION} -- start tag transition



feature {CHILD_DEFINITION} -- child state transition

	is_allowed_set (state: ELEMENT_STATE;
						 next_element: DEFINED_ELEMENT): BOOLEAN is
			-- Is `next_element' valid according to this child?
			-- My parent is the current_child_state and asks me what I think.
		require
			valid_state: state /= Void
			valid_element: next_element /= Void
		deferred
		ensure
			stack_unchanged: not Result implies
									 state.children.count = old state.children.count
			stack_changed: Result implies
									 state.children.count >= old state.children.count
		end

	is_allowed_stay (state: ELEMENT_STATE;
						  next_element: DEFINED_ELEMENT): BOOLEAN is
			-- Is `next_element' valid according to this child?
			-- This child is the current element.
			-- if it doesn't know, return False and set
			-- `state.authorative_answer' to False.
		require
			is_a_stay: state.active_child = Current
		deferred
		ensure
			stack_decrease: not Result implies
									 state.children.count <= old state.children.count
		end


feature {CHILD_DEFINITION} -- end tag transition

	any_required_child (state: ELEMENT_STATE): BOOLEAN is
			-- Is there, from the position record in `state', a required
			-- child definition?
		require
			state_not_void: state /= Void
		deferred
		end


end
