indexing

	description: "Single element child."

class

	CHILD_DEFINITION_NAME


inherit

	CHILD_DEFINITION


creation

	make


feature -- creation

	make (a_element: DEFINED_ELEMENT) is
		require
			element_not_void: a_element /= Void
		do
			element := a_element
		end


feature -- state

	element: DEFINED_ELEMENT


feature {CHILD_DEFINITION} -- start tag transition

	is_allowed_set (state: ELEMENT_STATE;
						 next_element: DEFINED_ELEMENT): BOOLEAN is
		do
			Result := element = next_element
			if Result then
				-- Reset, can be set by previous False, not sure if this
				-- is the right place to set it.
				state.set_authoritative_false (False)
				state.set_expected_element (Void)
			else
				state.set_authoritative_false (True)
				state.set_expected_element (element)
			end

			debug
				print ("CHILD_DEFINITION_NAME.answer_allowed_set%N")
				if Result then
					print ("  match: ")
				else
					print ("  authoritative no: ")
				end
				print (element.name.out)
				if Result then
					print (" = ")
				else
					print (" /= ")
				end
				print (next_element.name.out)
				print ("%N")
			end
		end

	is_allowed_stay (state: ELEMENT_STATE;
						  next_element: DEFINED_ELEMENT): BOOLEAN is
		do
			-- can't stay on a single element, have to move forward!
			Result := False
		end


feature {DEFINED_ELEMENT, CHILD_DEFINITION} -- end tag transition

	any_required_child (state: ELEMENT_STATE): BOOLEAN is
			-- return True if, from the position record in `state', there is
			-- a required child definition
		do
			debug
				print ("CHILD_DEFINITION_NAME.any_required_child.%N")
			end
			Result := True
			state.set_expected_element (element)
		end


invariant

	valid_element: element /= Void

end
